{-# LANGUAGE RecordWildCards, NamedFieldPuns, DeriveDataTypeable, DeriveGeneric, TemplateHaskell #-}

module Digiostelium.OldReportFormatTypes where

import GHC.Generics

import Data.Data
import Data.Aeson.TH
import Data.Typeable

import System.IO

import Digiostelium.AesonUtil



-- | Ways of writing out information
data OutputFormat =
  JSONOutput
  | YAMLOutput
  | PlainTextOutput
  | MarkdownOutput
  | GraphMLOutput
    deriving (Read, Show, Typeable, Data, Generic)

$(deriveJSON myJSONOpts ''OutputFormat)

-- | Where to send the output
data OutputDestination =
  AllToStdout
  | ToFilePerAgentId Bool FilePath
    -- ^ must include %d for where to put the agent's identifier
  | ToByteString
    deriving (Read, Show, Typeable, Data, Generic)

$(deriveJSON myJSONOpts ''OutputDestination)
