{-|
Module      : Digiostelium.BlockSize

Description : Class for getting and setting block sizes

Copyright   : © 2019 W. Garrett Mitchener

License     : GPL-3

Maintainer  : garrett.mitchener@gmail.com

Stability   : experimental

Portability : non-portable (GHC, POSIX)

-}

module Digiostelium.BlockSize (
  BlockSize(..)
  ) where

-- | This is kind of absurd but necessary because several parts
-- of the simulation have a notion of block size, and getting
-- them all set properly is turning out to be difficult.

class BlockSize t where

  -- | Get an object's block size.  Return 0 if it's not relevant.
  getBlockSize :: t -> Int
  getBlockSize _ = 0

  -- | Set an object's block size.  Don't change the object if it
  -- has no concept of block size.
  setBlockSize :: Int -> t -> t
  setBlockSize _ x = x
