{-# LANGUAGE
TemplateHaskell,
DeriveGeneric,
DeriveDataTypeable
#-}

{-|

Module: Digiostelium.ReportException

Description : Exceptions that can be generated when reporting about agents.

Copyright   : © 2019 W. Garrett Mitchener

License     : GPL-3

Maintainer  : garrett.mitchener@gmail.com

Stability   : experimental

Portability : non-portable (GHC, POSIX)

-}

module Digiostelium.ReportException where

import GHC.Generics

import Data.Data

import Control.Exception

data ReportException =
  JSONError String
  | ParseRatingError String
  | UnsupportedReportType String
  | UnsupportedFormat String
  | CantOverwriteFile String
  deriving (Read, Show, Eq, Ord, Data, Typeable, Generic)

instance Exception ReportException
