{-# LANGUAGE RankNTypes, ScopedTypeVariables #-}

{-|

Module: WGM.ExceptionUtil

Description: A few utilities for use with exceptions.

Copyright: © W. Garrett Mitchener 2017

License: GPL-3

Maintainer: garrett.mitchener@gmail.com

Stability: experimental

Portability: Portable

-}


module WGM.ExceptionUtil where

--import Control.Monad
import Control.Exception
import qualified Control.Exception as E
import Digiostelium.Logging


-- | Try an action and if an exception is thrown, display a
-- message and throw the exception out to the next handler.

excMsg :: forall a.
  String -- ^ description of where in the code this exception catch happened
  -> IO a -- ^ action that might throw an exception
  -> IO a
excMsg place axn = do
  mRes <- E.try axn
  case mRes of
    Right result ->
      return result
    Left (e :: SomeException) -> do
      msgError ("At " ++ place ++ " caught " ++ show e)
      throwIO e

